#ifndef MAT_HEAD
#define MAT_HEAD

#include <math.h>

class zespolone;
char* nazwafunkcji(int);
bool czygorna(int);

class zespolone{
private:
  long double rex,imx;
public:
  long double re() {return rex;}
  long double im() {return imx;}
  long double modul2() {return rex*rex+imx*imx;}
  zespolone() {rex=0; imx=0;}
  zespolone(long double x, long double y) {rex=x; imx=y;}
  zespolone operator*(zespolone z) {return zespolone(rex*z.rex-imx*z.imx,rex*z.imx+imx*z.rex);}
  zespolone odwrot() {long double m=rex*rex+imx*imx; return zespolone(rex/m,-imx/m);}
  zespolone operator+(zespolone z) {return zespolone(rex+z.rex,imx+z.imx);}
  zespolone operator+(long double d) {return zespolone(rex+d,imx);}
  zespolone operator*(long double m) {return zespolone(rex*m,imx*m);}
  zespolone operator-(zespolone z) {return zespolone(rex-z.rex,imx-z.imx);}
  zespolone operator-(long double d) {return zespolone(rex-d,imx);}
  bool operator==(zespolone z) {return ((rex==z.rex)&&(imx==z.imx));}
  bool operator==(long double d) {return ((rex==d) && (imx==0));}
  bool isNonPositiveInteger() {return ((rex<=0) && (imx==0) && (rex==int(rex)));}
  long double modul() {return sqrtl(modul2());}
  friend bool homografia(zespolone& z,zespolone a,zespolone b,zespolone c,zespolone d);
  friend bool zukowski(zespolone& z);
  friend bool expz(zespolone& z);
  friend bool kwadrat(zespolone& z,zespolone a,zespolone b);
  friend bool szescian(zespolone& z,zespolone a,zespolone b, zespolone c);
  friend bool digamma(zespolone& z);
  friend bool przeksztalcenie(zespolone& z,zespolone a,zespolone b, zespolone c, zespolone d,int jakie);
  friend bool arcsine(zespolone& z);
  friend bool logarithm(zespolone& z,bool czydodac=false);
  friend bool squareroot(zespolone& z);
  friend bool tangens(zespolone& z);
  friend bool arctangens(zespolone& z);
  friend bool arctangensh(zespolone& z);
  friend bool bezcwiartki(zespolone& z);
  friend bool SC2(zespolone& z);
  friend bool logcoth(zespolone& z);
  friend bool SC3(zespolone& z);
  friend bool SC4(zespolone& z);

};
zespolone liczbazarg(long double, long double);
zespolone potega(zespolone,long double,bool);
long double argum(zespolone, bool);
#endif

