#include "wykres.h"
#include <QColor>

wykres::wykres(QWidget *parent):QWidget(parent)
{
  hsize=200.0;
  vsize=200.0;
  hskip=100.0;
  setFixedWidth(4*hsize+hskip);
  setFixedHeight(2*vsize);
 
  // wyjsciowa homografia
  a=zespolone(1.0,0.0);
  b=zespolone(0.0,0.0);
  c=zespolone(0.0,0.0);
  d=zespolone(1.0,0.0);

  // srodek

  rangesource=zespolone(20.0,20.0);
  rangetarget=zespolone(10.0,10.0);
  centresource=zespolone(0.0,0.0);
  centretarget=zespolone(0.0,0.0);
  scaleellipse=2.0;
  scaleellipse2=2.0;

  typrysowania=0;
  typfunkcji=0;
  ilosclinii=50;
  a2=a;
  b2=b;
  c2=c;
  d2=d;
  centresource2=centresource;
  centretarget2=centretarget;
  rangesource2=rangesource;
  rangetarget2=rangetarget;
}

void wykres::paintEvent(QPaintEvent * /*event*/)
{
  opis_tekstu=QString("Current parameters: a=%1+%2i, b=%3+%4i, c=%5+%6i, d=%7+%8i.\n").arg(double(a.re())).arg(double(a.im())).arg(double(b.re())).arg(double(b.im())).arg(double(c.re())).arg(double(c.im())).arg(double(d.re())).arg(double(d.im()));
  opis_tekstu+=QString("Current mapping: %1.\n").arg(nazwafunkcji(typfunkcji));
  opis_tekstu+=QString("Scale on the left %1 x %2.").arg(double(rangesource.re())).arg(double(rangesource.im()));
  opis_tekstu+=QString("Scale on the right %1 x %2.").arg(double(rangetarget.re())).arg(double(rangetarget.im()));
  opis_tekstu+=QString("Coordinate centre on the left (%1,%2).").arg(double(centresource.re())).arg(double(centresource.im()));
  opis_tekstu+=QString("Coordinate centre on the right (%1,%2).").arg(double(centretarget.re())).arg(double(centretarget.im()));

  emit textchanged(opis_tekstu);

  QPainter pwykres(this);
  //  psource->setPen(Qt::SolidLine);
  int zero=qMin(int(width()*hskip/(2.0*hsize+hskip)),height());

  pwykres.translate(width()*hskip/(2*vsize),height()/2);
  pwykres.setPen(Qt::black);
  pwykres.scale(zero/vsize,zero/hsize);
  pwykres.drawLine(0,-vsize,0,vsize);
  pwykres.drawLine(-hsize,0,hsize,0);

  pwykres.setPen(Qt::black);
  pwykres.drawLine(hsize*2+hskip,-vsize,hsize*2+hskip,vsize);
  pwykres.drawLine(hsize+hskip,0,hsize*3+hskip,0);

  double xaa,yaa;
  zespolone z,v,v2;
  int ikk,jkk;
  if ((typrysowania==0) || (typrysowania==5))
    { 
      ikk=-ilosclinii;
      for (ikk=-2*ilosclinii; ikk<=2*ilosclinii; ikk++)
	{
	  
	  jkk=-20*int(vsize);
	  do
	    {
	      xaa=double(ikk)/double(ilosclinii)*hsize;
	      if (typrysowania==0) pwykres.setPen(QColor::fromHsv(61.0*double((2*ilosclinii+ikk))/double(ilosclinii),255,255));
	      else pwykres.setPen(QColor::fromHsv(30.5*double((2*ilosclinii+ikk))/double(ilosclinii),255,255));
	      yaa=double(jkk);
	      if ((abs(jkk)<vsize)&& (abs(ikk)<=ilosclinii)) 
		if (!czygorna(typfunkcji) || (jkk>0)) pwykres.drawPoint(xaa,-jkk);
	      xaa=xaa*rangesource.re()/hsize;
	      yaa=yaa*rangesource.im()/vsize;
	      z=zespolone(xaa,yaa)+centresource;
	      if (przeksztalcenie(z,a,b,c,d,typfunkcji)) 
		{
		  z=z+centretarget*(-1.0);
		  xaa=z.re()*hsize/rangetarget.re();
		  yaa=z.im()*vsize/rangetarget.im();
		  if ((abs(xaa)<hsize)&& (abs(yaa)<vsize))
		    { pwykres.drawPoint(xaa+2*hsize+hskip,-yaa);}
		}
	      if (abs(jkk)<3*int(vsize)) jkk++; else jkk=jkk+5;
	    }  
	  while (jkk<20*int(vsize));
	}
    }
  if ((typrysowania==1) || (typrysowania==5))
    { 
      jkk=-ilosclinii;
      for (jkk=-ilosclinii; jkk<=ilosclinii; jkk++)
	{
	  
	  ikk=-20*int(hsize);
	  do
	    {
	      yaa=double(jkk)/double(ilosclinii)*hsize;
	      if (typrysowania==1) 
		if (!czygorna(typfunkcji))
		  pwykres.setPen(QColor::fromHsv(127*double((ilosclinii+jkk))/double(ilosclinii),255,255));
		else
		  pwykres.setPen(QColor::fromHsv(255*double(abs(jkk))/double(ilosclinii),255,255));
	      else 
		if (!czygorna(typfunkcji))
		  pwykres.setPen(QColor::fromHsv(127+63.5*double((ilosclinii+jkk))/double(ilosclinii),255,255));
		else 
		  pwykres.setPen(QColor::fromHsv(127+127*double(abs(jkk))/double(ilosclinii),255,255));
	      xaa=double(ikk);      
	      if (abs(ikk)<hsize) 
		if (!czygorna(typfunkcji) || (yaa>0)) pwykres.drawPoint(ikk,-yaa);
	      xaa=xaa*rangesource.re()/hsize;
	      yaa=yaa*rangesource.im()/vsize;
	      z=zespolone(xaa,yaa)+centresource;
	      if (przeksztalcenie(z,a,b,c,d,typfunkcji)) 
		{
		  z=z+centretarget*(-1.0);
		  xaa=z.re()*hsize/rangetarget.re();
		  yaa=z.im()*vsize/rangetarget.im();
		  if ((abs(xaa)<hsize)&& (abs(yaa)<vsize))
		    { pwykres.drawPoint(xaa+2*hsize+hskip,-yaa);}
		}
	      if (abs(ikk)<3*int(hsize)) ikk++; else ikk=ikk+5;
	    }  
	  while (ikk<20*int(hsize));
	}
    }
  if ((typrysowania==2) || (typrysowania==3) || (typrysowania==6))
    { 
      jkk=0;
      for (jkk=0; jkk<=ilosclinii; jkk++)
	{
	  ikk=0;
	  do
	    {
	      xaa=hsize*double(jkk)/double(ilosclinii)*cosl(double(ikk)*0.2);
	      yaa=hsize*double(jkk)/double(ilosclinii)*sinl(double(ikk)*0.2);
	      if (typrysowania==3) yaa*=scaleellipse;
	      if (typrysowania==6) pwykres.setPen(QColor::fromHsv(127*double(jkk)/double(ilosclinii),255,255)); else pwykres.setPen(QColor::fromHsv(255*double(jkk)/double(ilosclinii),255,255));
	      if (!czygorna(typfunkcji) || (yaa>0)) pwykres.drawPoint(xaa,-yaa);
 xaa*=rangesource.re()/hsize;
 yaa*=rangesource.re()/hsize;
 z=zespolone(xaa,yaa)+centresource;
 if (przeksztalcenie(z,a,b,c,d,typfunkcji)) 
		{
		  z=z+centretarget*(-1.0);
		  xaa=z.re()*hsize/rangetarget.re();
		  yaa=z.im()*vsize/rangetarget.im();
		  if ((abs(xaa)<hsize)&& (abs(yaa)<vsize))
		    { pwykres.drawPoint(xaa+2*hsize+hskip,-yaa);}
		}
	      ikk++;
	    }  
	  while (ikk<1800);
	}
    }
  if ((typrysowania==4)||(typrysowania==6))
    { 
      jkk=0;
      for (jkk=0; jkk<=ilosclinii; jkk++)
	{
	  ikk=0;
	  do
	    {
	      xaa=0.2*double(ikk)*cosl(double(jkk)*3.14159265358979323846*2.0/double(ilosclinii));
	      yaa=0.2*double(ikk)*sinl(double(jkk)*3.14159265358979323846*2.0/double(ilosclinii));
	      if (czygorna(typfunkcji))	
		if (typrysowania==6) pwykres.setPen(QColor::fromHsv(127+int(255*double(jkk%ilosclinii)/double(ilosclinii))%127,255,255));
		else pwykres.setPen(QColor::fromHsv(int(511*double(jkk)/double(ilosclinii))%255,255,255));
	      else
		if (typrysowania==6) pwykres.setPen(QColor::fromHsv(127+255*double(jkk%ilosclinii/2)/double(ilosclinii),255,255));
		else pwykres.setPen(QColor::fromHsv(255*double(jkk)/double(ilosclinii),255,255));
	      if (ikk<5*hsize) 
		if (!czygorna(typfunkcji) || (yaa>0)) pwykres.drawPoint(xaa,-yaa);
 xaa*=5.0*rangesource.re()/hsize;
 yaa*=5.0*rangesource.re()/hsize;
 z=zespolone(xaa,yaa)+centresource;
 if (przeksztalcenie(z,a,b,c,d,typfunkcji)) 
		{
		  z=z+centretarget*(-1.0);
		  xaa=z.re()*hsize/rangetarget.re();
		  yaa=z.im()*vsize/rangetarget.im();
		  if ((abs(xaa)<hsize)&& (abs(yaa)<vsize))
		    { pwykres.drawPoint(xaa+2*hsize+hskip,-yaa);}
		}
	      if (ikk<5*hsize) ikk++; else ikk+=4;
	    }  
	  while (ikk<15*hsize);
	}
    }
}



